package gcaligner;

import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;
import java.awt.Color;
import javax.swing.border.LineBorder;
import javax.swing.SwingConstants;
import java.awt.Font;
import javax.swing.JPopupMenu;
import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;
import javax.swing.JTextPane;
import java.io.File;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Interface extends JFrame 
{
	private static final long serialVersionUID = 1L;
	private JTextField inputFileName;
	private JTextField intervalWeight;
	private JTextField numberOfColumns;
	private JButton run = null;
	public Interface() 
		{
			setResizable(false);
			// setIconImage(Toolkit.getDefaultToolkit().getImage(Interface.class.getResource("/images/test.jpg")));
			getContentPane().setBackground(Color.WHITE);
			setTitle("GCAligner 1.0");
			setSize(283,243);
			getContentPane().setLayout(null);
			
			JPanel panel1 = new JPanel();
			panel1.setBorder(new LineBorder(new Color(192, 192, 192), 3));
			panel1.setBackground(Color.WHITE);
			panel1.setBounds(-11, -20, 296, 79);
			getContentPane().add(panel1);
			panel1.setLayout(null);
			
			JLabel lblDellicourSLecocq = new JLabel("ebe.ulb.ac.be/ebe/Software.html");
			lblDellicourSLecocq.setBounds(25, 48, 167, 16);
			panel1.add(lblDellicourSLecocq);
			lblDellicourSLecocq.setFont(new Font("Arial", Font.PLAIN, 11));
			
			JLabel lblDellicourSLecocq_1 = new JLabel("Dellicour S, Lecocq T (2013)");
			lblDellicourSLecocq_1.setBounds(25, 31, 167, 16);
			panel1.add(lblDellicourSLecocq_1);
			lblDellicourSLecocq_1.setFont(new Font("Arial", Font.PLAIN, 12));
			
			JPanel panel2 = new JPanel();
			panel2.setBorder(new LineBorder(Color.LIGHT_GRAY, 3));
			panel2.setBackground(Color.WHITE);
			panel2.setBounds(-11, 51, 296, 173);
			getContentPane().add(panel2);
			panel2.setLayout(null);
			
			JLabel lblNewLabel = new JLabel("Inputfile (tab delimited): ");
			lblNewLabel.setFont(new Font("Arial", Font.PLAIN, 12));
			lblNewLabel.setBounds(26, 95, 180, 16);
			panel2.add(lblNewLabel);
			
			inputFileName = new JTextField();
			inputFileName.setFont(new Font("Arial", Font.PLAIN, 10));
			// inputFileName.setText("(without a \".txt\" extension)");
			inputFileName.setBounds(26, 125, 172, 22);
			panel2.add(inputFileName);
			inputFileName.setColumns(10);
			
			run = new JButton("RUN");
			run.setFont(new Font("Arial", Font.BOLD, 10));
			run.setBounds(207, 125, 64, 22);
			panel2.add(run);
			
			JButton open = new JButton("OPEN");
			open.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
				}
			});
			open.setFont(new Font("Arial", Font.BOLD, 10));
			open.setBounds(207, 92, 64, 22);
			panel2.add(open);
			
			JButton interrogationWeight = new JButton("?");
			interrogationWeight.setBounds(227, 22, 44, 22);
			panel2.add(interrogationWeight);
			interrogationWeight.setFont(new Font("Arial", Font.PLAIN, 11));
			
			final JPopupMenu popupMenu1 = new JPopupMenu();
			popupMenu1.setBorderPainted(false);
			popupMenu1.setFont(new Font("Arial", Font.PLAIN, 11));
			popupMenu1.setPopupSize(new Dimension(500, 75));
			addPopup(interrogationWeight, popupMenu1);
			
			JTextPane text1 = new JTextPane();
			text1.setFont(new Font("Arial", Font.PLAIN, 11));
			text1.setText("This is the weight parameter alpha (\u03B1) allowing to systematically increase or decrease the acceptance rate of a RT \u201Cequivalence\u201D (corresponding to the same compound signal) to another RT. Users are invited to begin with the default value of \u03B1 = 1 and then to decrease (i.e. \u03B1 = 0.5, 0.25, 0.125) or increase (i.e. \u03B1 = 2, 3, 4) this parameter in order to check if it can give better alignment results on their own initial dataset.");
			text1.setEditable(false);
			popupMenu1.add(text1);
			
			intervalWeight = new JTextField();
			intervalWeight.setFont(new Font("Arial", Font.PLAIN, 12));
			intervalWeight.setBounds(171, 21, 48, 24);
			panel2.add(intervalWeight);
			intervalWeight.setHorizontalAlignment(SwingConstants.CENTER);
			intervalWeight.setText("1");
			intervalWeight.setColumns(10);
			
			JLabel lblIntervalWeight = new JLabel("Weight parameter alpha: ");
			lblIntervalWeight.setBounds(26, 25, 189, 16);
			panel2.add(lblIntervalWeight);
			lblIntervalWeight.setFont(new Font("Arial", Font.PLAIN, 12));
			
			JLabel lblNberOfColumnsinjection = new JLabel("Nber of columns/sample:");
			lblNberOfColumnsinjection.setBounds(26, 58, 193, 16);
			panel2.add(lblNberOfColumnsinjection);
			lblNberOfColumnsinjection.setFont(new Font("Arial", Font.PLAIN, 12));
			
			numberOfColumns = new JTextField();
			numberOfColumns.setFont(new Font("Arial", Font.PLAIN, 12));
			numberOfColumns.setBounds(171, 54, 48, 24);
			panel2.add(numberOfColumns);
			numberOfColumns.setHorizontalAlignment(SwingConstants.CENTER);
			numberOfColumns.setText("3");
			numberOfColumns.setColumns(10);
			
			JButton interrogationNberOfColumns = new JButton("?");
			interrogationNberOfColumns.setBounds(227, 55, 44, 22);
			panel2.add(interrogationNberOfColumns);
			interrogationNberOfColumns.setFont(new Font("Arial", Font.PLAIN, 11));
			
			final JPopupMenu popupMenu2 = new JPopupMenu();
			popupMenu2.setBorderPainted(false);
			popupMenu2.setFont(new Font("Arial", Font.PLAIN, 11));
			popupMenu2.setPopupSize(new Dimension(500, 35));
			addPopup(interrogationNberOfColumns, popupMenu2);
			
			JTextPane text2 = new JTextPane();
			text2.setFont(new Font("Arial", Font.PLAIN, 11));
			text2.setEditable(false);
			text2.setText("This the number of columns per injection/sample in the input file (including the compulsory first columns with the retention times).");
			popupMenu2.add(text2);
			
			JButton interrogationInputFile = new JButton("?");
			interrogationInputFile.setFont(new Font("Arial", Font.PLAIN, 11));
			interrogationInputFile.setBounds(162, 92, 44, 22);
			panel2.add(interrogationInputFile);
			
			final JPopupMenu popupMenu3 = new JPopupMenu();
			popupMenu3.setBorderPainted(false);
			popupMenu3.setFont(new Font("Arial", Font.PLAIN, 11));
			popupMenu3.setPopupSize(new Dimension(500, 90));
			addPopup(interrogationInputFile, popupMenu3);
			
			JTextPane text3 = new JTextPane();
			text3.setFont(new Font("Arial", Font.PLAIN, 11));
			text3.setText("GCAligner needs input files in a \u00AB.txt\u00BB tab delimited format. The first column of each sample/injection must always be the RT column. The program does not read the other columns, which will only be copied in the output file. The number of additional columns to the RT column is not limited but has to be specified before running the program (cfr. GCAligner manual). Empty data are not allowed. The two first lines are not read. They can contain any useful information for users but input files need to present two lines before the different columns per sample.\r");
			text3.setEditable(false);
			popupMenu3.add(text3);
			
			interrogationNberOfColumns.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent arg0) {
					popupMenu2.show(arg0.getComponent(),
							arg0.getX(), arg0.getY());
				}
			});
			
			interrogationWeight.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent arg0) {
					popupMenu1.show(arg0.getComponent(),
							arg0.getX(), arg0.getY());
				}
			});
			
			interrogationInputFile.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent arg0) {
					popupMenu3.show(arg0.getComponent(),
							arg0.getX(), arg0.getY());
				}
			});
		
			final JFileChooser fileChooser = new JFileChooser();

			open.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent arg0) {
				int returnVal = fileChooser.showOpenDialog(null);
				if (returnVal == JFileChooser.APPROVE_OPTION) 
					{
						File selection = fileChooser.getSelectedFile();
						inputFileName.setText(selection.getAbsolutePath());
					}
				}
			});
		}
	
	JButton getJButton() 
		{
			return run;
		}
	
	public String getInputNameText() 
		{
			String inputNameText = inputFileName.getText();
			return inputNameText;
		}
	
	public String getIntervalWeightText() 
		{
			String intervalWeightText = intervalWeight.getText();
			return intervalWeightText;
		}
	
	public String getNumberOfColumnsPerInjectionText() 
		{
			String getNumberOfColumnsPerInjectionText = numberOfColumns.getText();
			return getNumberOfColumnsPerInjectionText;
		}
	
	private static void addPopup(Component component, final JPopupMenu popup) 
		{
		}
}

