package gcaligner;

// Class created by Simon Dellicour (April 2011).

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;

public class MainClass 
{
	public static ArrayList<String> finalArray;
	// data coming from the interface :
	public static Interface window;
	public static JButton start;
	public static String inputName;
	public static String intervalWeightText;
	public static double intervalWeight;
	public static String numberOfColumnsPerInjectionText;
	public static double numberOfColumnsPerInjection;
	
	// data coming from the inputFileReader :
	public static ArrayList<ArrayList <Double>> originalArray;

	public static void main(String[] args) {
		window = new Interface(); // creation of the interface.
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.setVisible(true); // necessary line to add to have a nice window.
		// window.setIconImage(new ImageIcon("Icon.PNG").getImage());
		start = window.getJButton();

		start.addActionListener(new ActionListener() 
			{
				public void actionPerformed(ActionEvent e) 
					{
						// inputName = (window.getInputNameText() + ".txt");
						inputName = window.getInputNameText();
						intervalWeightText = window.getIntervalWeightText();
						intervalWeight = Double.valueOf(intervalWeightText);
						numberOfColumnsPerInjectionText = window.getNumberOfColumnsPerInjectionText();
						numberOfColumnsPerInjection = Double.valueOf(numberOfColumnsPerInjectionText);
						
						InputFileReader input = new InputFileReader(); 
							try {
								input.readInput(inputName);
							} catch (IOException e3) {
								// TODO Auto-generated catch block
								e3.printStackTrace();
							}
						
						finalArray = new ArrayList<String>();
						finalArray.add(input.individualsList);
						finalArray.add(input.origins);
						
						double highestGoodRetentionTime = 0;
						
						int c = 0; // (counter).
						int e2 = 0;
						for (int i = 0; i < input.numberOfIndividuals; i ++)
							{
								if (input.individuals.get(i).columns.size() > 1)
									{
										e2 = e2 + 1;
									}
							}
						
						while (e2 > 1) // while all the individuals' first lines are not analyzed.
							{
								String row = new String();
								ArrayList<Double> rowRetentionTimes = new ArrayList<Double>(); // this ArrayList will contain all the retention times of the considered row.
								ArrayList<Double> nextRowRetentionTimes = new ArrayList<Double>(); // this ArrayList will contain all the retention times of the considered row.
								ArrayList<Double> rowIndividualsID = new ArrayList<Double>(); // this ArrayList will contain all the individual ID's of the considered row.
								ArrayList<Double> goodRetentionID = new ArrayList<Double>(); // Arraylist which will contain only individuals ID with a "correct" retention times.
								
								// construction of the rowRententionTimes and rowIndividuals ArrayList's :
								for (int j = 0; j < input.numberOfIndividuals; j++)
									{
										if (input.individuals.get(j).retensionTimesString.size() > 1
												&& input.individuals.get(j).retensionTimesString.get(0).length() > 0
												&& input.individuals.get(j).retensionTimesString.get(1).length() > 0)
											{	
												rowRetentionTimes.add(Double.valueOf(input.individuals.get(j).retensionTimesString.get(0)));
												nextRowRetentionTimes.add(Double.valueOf(input.individuals.get(j).retensionTimesString.get(1)));
												rowIndividualsID.add(Double.valueOf(input.individuals.get(j).individualID));
											}
									} 
								
								// (1) determination of the weakest retention time :
								double weakestTime = Double.valueOf(rowRetentionTimes.get(0)).doubleValue();
								double weakestTimeID = Double.valueOf(rowIndividualsID.get(0)).doubleValue();
								double tf1 = Double.valueOf(input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(1)).doubleValue(); // NOUVEAU !!!
								for (int j = 1; j < rowIndividualsID.size(); j++)
									{
										if (rowRetentionTimes.get(j).doubleValue() < weakestTime)
											{
												weakestTime = rowRetentionTimes.get(j).doubleValue();
												weakestTimeID = rowIndividualsID.get(j).doubleValue();
											}
										if (nextRowRetentionTimes.get(j).doubleValue() < tf1) // NOUVEAU !!!
											{
												tf1 = nextRowRetentionTimes.get(j).doubleValue();
											}
									}
								goodRetentionID.add(Double.valueOf(weakestTimeID));
								
								for (int j = 0; j < rowIndividualsID.size(); j++) // to remove the weakestTimeID of the rowIndividualsID;
									{
										if (rowIndividualsID.get(j).doubleValue() == weakestTimeID)
											{
												rowIndividualsID.remove(j);
												rowRetentionTimes.remove(j);
											}
									}
								
								double tf0 = Double.valueOf(input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(0)).doubleValue(); // NOUVEAU !!!
								                                                                          
								// comparison with the other retention times on the same row :		
								int d = (int) rowIndividualsID.size();
								while (d > 0)
									{                                                            
										double nearestTime = rowRetentionTimes.get(0).doubleValue(); // initialization.     
										double nearestTimeID = rowIndividualsID.get(0).doubleValue(); // initialization.
										double delta = nearestTime - weakestTime;
										
										// (2) determination of the nearest rentention time :
										for (int j = 1; j < rowIndividualsID.size(); j++)
											{																
												if (rowRetentionTimes.get(j).doubleValue() - weakestTime < delta)
													{
														delta = rowRetentionTimes.get(j).doubleValue() - weakestTime;           
														nearestTimeID = (int) rowIndividualsID.get(j).doubleValue();
													}
											}
										
										// (3) comparison between the nearest and weakest retention times (+ cfr. external notes about the algorithm) :
										if (input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(1).length() > 0											
												&& input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(1).length() > 0)
											{   
												// double tf1 = Double.valueOf(input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(1)).doubleValue();
												// double tf0 = Double.valueOf(input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(0)).doubleValue();
												double tp1 = Double.valueOf(input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(1)).doubleValue();
												double tp0 = Double.valueOf(input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(0)).doubleValue();
												if ((tf1-tp0) > ((tp0-tf0)*intervalWeight))
													{ 								// System.out.println(tf1 + "-" + tp0 + " " + tf0 + "-" + tp0);
														// (2.2)
														if ((tp1-tp0) > ((tp0-tf0)*intervalWeight))
															{	
																// (2.3)
																if ((tf0-highestGoodRetentionTime) > ((tp0-tf0)*intervalWeight)) // NOUVEAU !!!
																	{	
																		goodRetentionID.add(Double.valueOf(nearestTimeID));
																
																		for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
																			{
																				if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																					{
																						rowIndividualsID.remove(k);
																						rowRetentionTimes.remove(k);
																					}
																			}
																		d = d - 1;
																	}
																else // NOUVEAU !!!
																	{
																		for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
																			{
																				if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																					{
																						rowIndividualsID.remove(k);
																						rowRetentionTimes.remove(k);
																					}
																			}
																		d = d - 1;
																	}
															}
														else
															{
																for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
																	{
																		if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																			{
																				rowIndividualsID.remove(k);
																				rowRetentionTimes.remove(k);
																			}
																	}
																d = d - 1;
															}
													}
												else
													{
														for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
															{
																if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																	{
																		rowIndividualsID.remove(k); 																					
																		rowRetentionTimes.remove(k);
																	}
															}
														d = d - 1;
													}
												
												if (tp1 < tf1) // NOUVEAU !!! : if (tp1 > tf1), the alignment consider bigger intervals and if (tp1 < tf1), smallest intervals.
													{
														tf1 = tp1;
													}
											} 
										
										// this step shouldn't be necessary because last individuals' line are not analyzed. 
										else if (input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(1).length() > 0)
											{	System.out.println("inside 1");
												//// double tf0 = Double.valueOf(input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(0)).doubleValue();
												double tp1 = Double.valueOf(input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(1)).doubleValue();
												double tp0 = Double.valueOf(input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(0)).doubleValue();
												
														if ((tp1-tp0) > (tp0-tf0))
															{
																goodRetentionID.add(Double.valueOf(nearestTimeID));
															
																for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
																	{
																		if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																			{
																				rowIndividualsID.remove(k);
																				rowRetentionTimes.remove(k);
																			}
																	}
																d = d - 1;
															}
														else
															{
																for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
																	{
																		if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																			{
																				rowIndividualsID.remove(k); 
																				rowRetentionTimes.remove(k);
																			}
																	}
																d = d - 1;
															}
													}
										
										// this step shouldn't be necessary because last individuals' line are not analyzed. 
										else if (input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(1).length() > 0)
											{   System.out.println("inside 2");
												//// double tf1 = Double.valueOf(input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(1)).doubleValue();
												//// double tf0 = Double.valueOf(input.individuals.get((int) weakestTimeID - 1).retensionTimesString.get(0)).doubleValue();
												// double tp1 = Double.valueOf(input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(1)).doubleValue();
												double tp0 = Double.valueOf(input.individuals.get((int) nearestTimeID - 1).retensionTimesString.get(0)).doubleValue();
												if ((tf1-tp0) > (tp0-tf0))
													{
														for (int j = 0; j < rowIndividualsID.size(); j++) // to remove the weakestTimeID of the rowIndividualsID;
															{
																goodRetentionID.add(Double.valueOf(nearestTimeID));
																	
																for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
																	{
																		if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																			{
																				rowIndividualsID.remove(k);
																				rowRetentionTimes.remove(k);
																			}
																	}
																d = d - 1;
															}
													}
												else
													{
														for (int k = 0; k < rowIndividualsID.size(); k++) // to remove the nearestTimeID of the rowIndividualsID;
															{
																if (rowIndividualsID.get(k).doubleValue() == nearestTimeID)
																	{
																		rowIndividualsID.remove(k);
																		rowRetentionTimes.remove(k);
																	}
															}
														d = d - 1;
													}
											}
									} // System.out.println();
								
								// (4) individuals' lines with an "accepted" (corresponding) retention times are put at the end of a the output ArrayList ("finalArray").
								for (int j = 0; j < input.numberOfIndividuals; j++)
									{
										int a = 0;
										for (int k = 0; k < goodRetentionID.size(); k++)
											{
												if (input.individuals.get(j).individualID == goodRetentionID.get(k)
														&& input.individuals.get(j).columns.size() > 1)
													{
														if (Double.valueOf(input.individuals.get(j).retensionTimesString.get(0)) > highestGoodRetentionTime)
															{
																highestGoodRetentionTime = Double.valueOf(input.individuals.get(j).retensionTimesString.get(0));
															}
														row = row + input.individuals.get(j).columns.get(0) + "	";
														input.individuals.get(j).columns.remove(0);
														input.individuals.get(j).retensionTimesString.remove(0);
														a = a + 1;
													}
											}
										if (a == 0)
											{
												// row = row + "	" + "	" + "	";
												for (int l = 0; l < (int) numberOfColumnsPerInjection; l++)
													{
														row = row + "	";
													}
											}
									}
								
								e2 = 0; // "e2" counter update.
								for (int j = 0; j < input.numberOfIndividuals; j ++)
								{
									if (input.individuals.get(j).retensionTimesString.size() > 1
											&& input.individuals.get(j).retensionTimesString.get(0).length() > 0
											&& input.individuals.get(j).retensionTimesString.get(1).length() > 0)
										{
											e2 = e2 + 1;
										}
								}
								
								finalArray.add(row); c = c + 1; // System.out.println(e2);
							} 
						
						// construction of the .txt or .xls output file :
						String finalRow = new String();
						for (int i = 0; i < input.numberOfIndividuals; i ++)
							{
								finalRow = finalRow + input.individuals.get(i).columns.get(0) + "	";
							}
						finalArray.add(finalRow);
						
						OutputFileWriter output1 = new OutputFileWriter();
							try {
									output1.writeOutput1(finalArray, "GCAligner_output_file.xls");
								} catch (IOException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
					} // end of "addActionListener".
				});
	} // end of "main".
}
